# This file is sourced by the OOMMF account server to determine what
# processes it is permitted to "export".  That is, it defines a list of
# programs on the local host which it will launch in response to a request
# received over a network socket. 
#
# The entries in this list are stored as a Tcl array which maps an alias
# by which a program is known remotely to information needed to launch
# it locally.

# The variable master(root) is already set to the name of this directory by
# the script which sources this file.

# Still need better way to handle platform differences:  --nofork, 
#	name of the wish executable, and the name of the directory for binaries
# For now, configure here:
set mywish wish
set nofork --nofork
set bindir bin-sun

array set Omf_export [list \
    mmDisp	[concat [file join $master(root) mmdisp $bindir mmdisp] \
			$nofork --server] \
    mmSolve2D	[list [file join $master(root) mmsolve $bindir mmsolve] \
			[file join $master(root) mmsolve mmSolve2D.tcl]] \
    mmGraph	[list $mywish [file join $master(root) oommf library net0.0 \
			threads mmGraph.tcl]] \
    mmLog	[list $mywish [file join $master(root) oommf library net0.0 \
			threads mmLog.tcl]] \
    mmDataTable	[list $mywish [file join $master(root) oommf library net0.0 \
			threads mmDataTable.tcl]] \
    mmProbEd	[list $mywish [file join $master(root) mmpe dmif.tcl]] \
]

