# FILE: mmDataTable.tcl
#
# Display Table of data values
#

# Set up for auto-loading
set master(relhdir) [string trimright [file dirname [info script]] ./]
set master(abshdir) [file join [pwd] $master(relhdir)]
set master(pdir) [file dirname $master(abshdir)]
set master(libdir) [file dirname $master(pdir)]
if {[lsearch $auto_path $master(libdir)] < 0} {
    lappend auto_path $master(libdir)
}

# Support libraries
package require Tk
package require em
package require net

set menubar [frame .mb -borderwidth 2 -relief raised]
set dmb [menubutton .dmb -text Data -menu .dmb.menu -underline 0]
set dmenu [menu .dmb.menu -tearoff 0]
pack $dmb -side left -in $menubar
pack $menubar -side top -fill x
set panel [frame .panel -relief groove]
pack $panel -side bottom -fill both -expand 1

proc DisplayListAppend { label } {
    global panel unit onoff
    regsub -all "\[ \r\t\n\]" $label {} foo
    if {$onoff($label)} {
    if {![winfo exists $panel.w$foo]} {
        set item [frame $panel.w$foo]
        if {[string length $unit($label)]} {
            set txt "$label ($unit($label)):"
        } else {
            set txt "$label:"
        }
        set l [label $item.label -text $txt -anchor e]
        set v [label $item.value -textvariable value($label) -anchor w]
        pack $l $v -side left -in $item -fill x
        pack $item -side top -fill x
    }
    } else {
    if {[winfo exists $panel.w$foo]} {
        destroy $panel.w$foo
    }
    }
}
set protocol [net_protocol new -name "OOMMF DataTable protocol 0.0"]
$protocol AddMessage start HasGui {} {
    return [list start [list 0 0]]
}
$protocol AddMessage start DataTable { triples } {
    global unit value dmenu onoff
    foreach trip $triples {
        set lbl [lindex $trip 0]
        if {![info exists unit($lbl)]} {
            set unit($lbl) [lindex $trip 1]
            set onoff($lbl) 0
            regsub -all "\[\r\n\t\]" $lbl " " txt
            $dmenu add check -label $txt \
                    -variable onoff($lbl) \
                    -command [list DisplayListAppend $lbl]
        }
        set value($lbl) [lindex $trip 2]
    }
    return [list start [list 0 0]]
}
set server [net_server new -protocol $protocol -alias mmDataTable -log em_nop]
$server Start 0
wm title . mmDataTable<[pid]>
bind . <Destroy> {$protocol delete; after 2000 exit}
vwait omf_forever
